#include "interface.h"
#include "ui_interface.h"
#include <QStringList>


#include <QKeyEvent>

Interface::Interface(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::Interface)
{
    ui->setupUi(this);

//    QPixmap pixmap("/home/bolet/cole/MM-Projecte/Client/btConnect.png");
//    QIcon ButtonIcon(pixmap);
//    ui->btFind->setIcon(ButtonIcon);
//    ui->btFind->setIconSize(pixmap.rect().size());

    udpSrvr = new myUdp(0);
    tcpCli = new tcpClient(0);
    optDialog = new Options;

    // find out which IP to connect to
        /*QString ipAddress;
        QList<QHostAddress> ipAddressesList = QNetworkInterface::allAddresses();
        // Recorre todas las ip
            for (int i = 0; i < ipAddressesList.size(); ++i) {
                    //if (ipAddressesList.at(i) != QHostAddress::LocalHost &&
                    if (ipAddressesList.at(i).toIPv4Address()) {
                        ipAddress = ipAddressesList.at(i).toString();
                        ui->cbNetworks->insertItem(0,ipAddress);
                        //qDebug()<<ipAddress;
                    }
                }*/

    connect(udpSrvr,SIGNAL(respostaObtinguda(QString)),
            this,SLOT(iniciaTcpSrv(QString)) );

    connect(tcpCli,SIGNAL(sendToInterface(QString)),
            ui->lbConnectionStatus,SLOT(setText(QString)));

    connect(tcpCli,SIGNAL(sendTcpConnected()),
            this,SLOT(tcpIsConnected()) );

    //Connect all relase buttons with the standby
    connect(ui->btBack,SIGNAL(released()), this,SLOT(standBy()) );
    connect(ui->btFor,SIGNAL(released()), this,SLOT(standBy()) );
    connect(ui->btLeft,SIGNAL(released()), this,SLOT(standBy()) );
    connect(ui->btRight,SIGNAL(released()), this,SLOT(standBy()) );
}

Interface::~Interface()
{
    tcpCli->vDisconnectTcp();
    delete ui;
}


/* ################# FIND THE ROBOT  ################# */

void Interface::on_btFind_clicked()
{
    if (ui->btFind->text() == "&Connect"){
        ui->lbConnectionStatus->setText("Finding...");
        //QString address =  ui->cbNetworks->currentText() ;
        if (optDialog->isAdHocMode()){
            tcpSrvrConection (optDialog->getIp());
        } else {
            udpSrvr->iniciaBusqueda(QHostAddress(optDialog->getIp()), optDialog->getBroadcast());
        }
        //udpSrvr->iniciaBusqueda(QHostAddress("192.168.45.103"), false);
    } else if (ui->btFind->text() == "&Disconnect"){
        tcpCli->vDisconnectTcp();
        ui->btFind->setText("&Connect");
        ui->lbConnectionStatus->setText("Alone...");
        tcpIsDisConnected();

    }

}
void Interface::iniciaTcpSrv(QString ipOrigen){
    tcpSrvrConection(ipOrigen);
}
void Interface::tcpSrvrConection (QString ipOrigen){
    ui->lbConnectionStatus->setText("Inicializing TCP Client to " + ipOrigen);
    udpSrvr->disconnectServer();
    qDebug()<<ipOrigen;
    tcpCli->conectarTcpClient(ipOrigen);
}

//CONNECTED
void Interface::tcpIsConnected() {
    ui->btFind->setText("&Disconnect");

    ui->btBack->setEnabled(true);
    ui->btBack->setShortcut(tr("s"));

    ui->btFor->setEnabled(true);
    ui->btFor->setShortcut(tr("w"));

    ui->btLeft->setEnabled(true);
    ui->btLeft->setShortcut(tr("a"));

    ui->btRight->setEnabled(true);
    ui->btRight->setShortcut(tr("d"));

    ui->btEnjegaCoche->setEnabled(true);

    ui->webView->show();
    QString camUrl = "http://"+tcpCli->srvIp+":8080/JSStream";
    qDebug()<< camUrl +"   camUrl";
    ui->webView->load(QUrl(camUrl));
    //ui->webView->load(QUrl("http://192.168.45.103:8080/JSStream"));
}
/* ################# SEND MESSAGES ################# */

void Interface::on_pushButton_clicked()
{
    if(optDialog->exec() == QDialog::Accepted){
        //ui->lbOrdre->setText(dl->qszComanda() );
        //ui->lbComentari->setText(dl->qszComentari());
    }
}

void Interface::on_btEnjegaCoche_clicked()
{
    if (ui->btEnjegaCoche->text() == "ON"){
        tcpCli->vSendMessage("on");
        ui->btEnjegaCoche->setText("OFF");
    } else {
        tcpCli->vSendMessage("off");
        ui->btEnjegaCoche->setText("ON");
    }
}

void Interface::on_btFor_pressed()
{
    tcpCli->vSendMessage("fw");
}

void Interface::standBy(){
    tcpCli->vSendMessage("st");
}
void Interface::on_btBack_pressed()
{
    tcpCli->vSendMessage("bw");
}

void Interface::on_btLeft_pressed()
{
    tcpCli->vSendMessage("le");
}

void Interface::on_btRight_pressed()
{
    tcpCli->vSendMessage("ri");
}

//DISCONECT ALL
void Interface::tcpIsDisConnected() {
    ui->webView->hide();
    ui->btBack->setEnabled(false);
    ui->btFor->setEnabled(false);
    ui->btLeft->setEnabled(false);
    ui->btRight->setEnabled(false);
    ui->btEnjegaCoche->setEnabled(false);
}

void Interface::keyPressEvent(QKeyEvent *event)
{
    if(event->key() == Qt::Key_Escape)
    {
        //myLabel->setText("You pressed ESC");
        qDebug()<< "esc";
        tcpCli->vSendMessage("fw");
    }
}
void Interface::keyReleaseEvent(QKeyEvent *event)
{
    if(event->key() == Qt::Key_Escape)
    {
        //myLabel->setText("You released ESC");
        qDebug()<< "rel";
        tcpCli->vSendMessage("st");
    }
}

