#ifndef INTERFACE_H
#define INTERFACE_H

#include <QMainWindow>
#include "myudp.h"
#include "tcpclient.h"
#include "options.h"

namespace Ui {
class Interface;
}

class Interface : public QMainWindow
{
    Q_OBJECT

public:
    explicit Interface(QWidget *parent = 0);
    ~Interface();
    myUdp *udpSrvr;
    tcpClient *tcpCli;
    Options *optDialog;
    bool connectionSucces = false;

protected:
    void keyPressEvent(QKeyEvent *);
    void keyReleaseEvent(QKeyEvent *);


private slots:
    void on_btFind_clicked();
    void iniciaTcpSrv (QString ipOrigen);
    void tcpIsConnected();
    void tcpIsDisConnected();

    void on_pushButton_clicked();

    void standBy () ;

    void on_btEnjegaCoche_clicked();

    void on_btFor_pressed();
    void on_btBack_pressed();

    void on_btLeft_pressed();

    void on_btRight_pressed();

private:
    void tcpSrvrConection (QString ipOrigen);
    Ui::Interface *ui;
};

#endif // INTERFACE_H
