#include "myudp.h"
#define TX_PORT_DEFAULT 6000
#define RX_PORT_DEFAULT 6001

myUdp::myUdp(QObject *parent) :
    QObject(parent)
{

}

void myUdp::iniciaBusqueda(QHostAddress ipN, bool bdc){
    txPort = TX_PORT_DEFAULT;
    network = ipN;

    if (!serverIsOpen){
        conectaServidor ();
    }
    if (bdc){
        enviaMissatge("lifeTest",QHostAddress("255.255.255.255") );
    } else {
        enviaMissatge("lifeTest",network );
    }

}

/* ############ TX DE TRAMA ############ */
void myUdp::enviaMissatge (QString qsz, QHostAddress ip){

    quint16 nPortTx= txPort;
    vTrametSocolUdp(qsz.toLatin1(),
                    ip,
                    nPortTx);
}
void myUdp::vTrametSocolUdp(QByteArray datagram,QHostAddress adreca,quint16 port){
    QUdpSocket *udpSocketTX = new QUdpSocket(this);

    qDebug() << "vTrametSocolUdp";
    udpSocketTX->writeDatagram(datagram.data(),datagram.size(),adreca,port);
    delete udpSocketTX;

}

/* ############ RX DE TRAMA ############ */
/*CONEXIO SERVIDOR*/
void myUdp::conectaServidor( ){
    server = new QUdpSocket(this);
    //server->bind(network, RX_PORT_DEFAULT);
    server->bind(RX_PORT_DEFAULT);
    connect(server, SIGNAL(readyRead()),this, SLOT(vDatagramaRxSV()));
    serverIsOpen = true;
}
void myUdp::vDatagramaRxSV(){
    while (server->hasPendingDatagrams()) {
         QByteArray datagram;
         QHostAddress adrecaOrigen;
         quint16 portOrigen;
         datagram.resize(server->pendingDatagramSize()) ;
         server->readDatagram(datagram.data(),datagram.size(),
                                 &adrecaOrigen,&portOrigen);
         vInterpretaTramaRebudaUdp(datagram,adrecaOrigen);
     }
}
/*INTERPRETACIO TRAMA*/
void myUdp::vInterpretaTramaRebudaUdp(QByteArray datagrama,QHostAddress adrecaOrigen){
     QString qsz = trUtf8("%1").arg(datagrama.data()) ;
     qDebug()<< qsz;
     if (qsz == "Dalai_Lama"){
         missatgeOk(adrecaOrigen.toString());
     }

}
/*DISCONNECT*/
void myUdp::disconnectServer (){
    if (serverIsOpen){
        disconnect(server);
        server->abort();
        delete server;
        serverIsOpen = false;
    }
}

/* ############ FINALITZACIÓ DEL SERVIDOR ############ */
void myUdp::missatgeOk (QString ipOrigen){
     emit respostaObtinguda (ipOrigen);
}
