#include "tcpclient.h"

#define RX_PORT_DEFAULT 6006
#define TX_PORT_DEFAULT 6005

tcpClient::tcpClient(QObject *parent) :
    QObject(parent)
{
    txPort = TX_PORT_DEFAULT;
    rxPort = RX_PORT_DEFAULT;
    bConnected = false;
}

void tcpClient::conectarTcpClient (QString ip){
    srvIp = ip;
    if(bConnectTcp() ){
                qDebug() << "Connected through TCP";
                sendToInterface("Connected to TCP server on "+srvIp+
                                ":"+QString::number(txPort) );
                emit sendTcpConnected ();
    }else{
                vDisconnectTcp();
                qDebug() << "Cannot be connected through TCP";
                sendToInterface("Can Not Connect to TCP srvr");
    }
}

bool tcpClient::bConnectTcp()
{
    //QByteArray data; // <-- fill with data

    _pSocket = new QTcpSocket( this ); // <-- needs to be a member variable: QTcpSocket * _pSocket;
    connect( _pSocket, SIGNAL(readyRead()), SLOT(readTcpData()) );

    _pSocket->connectToHost(srvIp, txPort);
    if( _pSocket->waitForConnected() ) {
        _pSocket->write( "data" );
        qDebug() << "TCP connected";
        bConnected = true;
    }else{
        qDebug() << "TCP disconnected";
        bConnected = false;
    }
    return bConnected;
}

void tcpClient::vDisconnectTcp(){
    if(bConnected){
        _pSocket->close();
        disconnect(_pSocket);
        qDebug() << "Disconnected";
        bConnected = false;
    }
}

void tcpClient::readTcpData()
{
    static int nCmpt = 0;
    QByteArray data = _pSocket->readAll();
    QString qsz;
    if(data.length()){
        nCmpt++;
        qsz = trUtf8("%3 %1 %2").arg(nCmpt).arg(data.mid(4).data()).arg(data.length());
        //qDebug() << qsz.toLatin1();
        /*int x = qsz.indexOf("\"");
        int y = qsz.indexOf("\"",x+1);*/
        //data = data.mid(x,y-x-1);
        //ui->etRebut->setText(data.mid(4));
        //qDebug() << trUtf8("x = %1, y = %2").arg(x).arg(y).toLatin1();
        vManageReceivedData(data);
    }
}

void tcpClient::vManageReceivedData(QByteArray qbaData){
    //qDebug() << "vManageReceivedData : " <<  qbaData.mid(4).data();
    emit vReceivedTcp(qbaData.mid(4).data());
}

void tcpClient::vSendMessage(QString qsz){
    _pSocket->write(qsz.toUtf8());

}
